controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\SqlDataProvider;
use yii\data\ActiveDataProvider;
use app\models\Ciclista;
use app\models\Puerto;
use app\models\Equipo;
use app\models\Etapa;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    public function actionConsulta1(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("COUNT(*) AS numciclistas"),
            'pagination'=>[
                'pageSize'=>1,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['numciclistas'],
            "titulo"=>"Consulta 1 con Active Record",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT COUNT(*) FROM ciclista AS numciclistas",
        ]);
        
        
    }
    
    public function actionSegundaconsulta1(){
        
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT COUNT(*)AS numciclistas FROM ciclista ",
            
            'pagination'=>[
                'pageSize' => 1,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['numciclistas'],
            "titulo"=>"Consulta 2 con DAO",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT COUNT(*) FROM ciclista AS numciclistas",
        ]);
}
 public function actionConsulta2(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("COUNT(*) AS numciclistas")
                ->where("nomequipo='Banesto'"),
            'pagination'=>[
                'pageSize'=>1,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['numciclistas'],
            "titulo"=>"Consulta 2 con Active Record",
            "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
            "sql"=>"SELECT COUNT(*) FROM ciclista AS numciclistas WHERE nomequipo='Banesto'",
        ]);
        
        
    }
    
    public function actionSegundaconsulta2(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT COUNT(*)AS numciclistas FROM ciclista WHERE nomequipo='Banesto'",
         
            'pagination'=>[
                'pageSize' => 1,
            ]
        ]);
         return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['numciclistas'],
            "titulo"=>"Consulta 2 con DAO",
            "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
            "sql"=>"SELECT COUNT(*) FROM ciclista WHERE nomequipo='Banesto'",
        ]);
}

public function actionConsulta3(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("AVG(edad) AS mededad"),
            'pagination'=>[
                'pageSize'=>1,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 3 con Active Record",
            "enunciado"=>"Edad media de los ciclistas",
            "sql"=>"SELECT AVG(edad)AS mededad FROM ciclista;",
        ]);
        
        
    }
    
     public function actionSegundaconsulta3(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"select avg(edad) as mededad from ciclista",
         
            'pagination'=>[
                'pageSize' => 1,
            ]
        ]);
         return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 3 con DAO",
            "enunciado"=>"Edad media de los ciclistas",
            "sql"=>"SELECT AVG(edad)AS mededad FROM ciclista;",
        ]);
}
    
    public function actionConsulta4(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("AVG(edad) AS mededad")
                ->where("nomequipo='Banesto'"),
            'pagination'=>[
                'pageSize'=>1,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 3 con Active Record",
            "enunciado"=>" La edad media de los del equipo Banesto",
            "sql"=>"SELECT AVG(edad) FROM ciclista AS mededad WHERE nomequipo='Banesto'",
        ]);
        
        
    }
    
    public function actionSegundaconsulta4(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"select avg(edad) as mededad from ciclista where nomequipo='Banesto'",
         
            'pagination'=>[
                'pageSize' => 1,
            ]
        ]);
         return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 4 con DAO",
            "enunciado"=>"La edad media de los del equipo Banesto",
            "sql"=>"SELECT AVG(edad)AS mededad FROM ciclista WHERE nomequipo='Banesto'",
        ]);
}

public function actionConsulta5(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("AVG(edad) AS mededad")
                ->groupBy('nomequipo'),
            'pagination'=>[
                'pageSize'=>1,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 5 con Active Record",
            "enunciado"=>" La edad media de los ciclistas por cada equipo",
            "sql"=>"SELECT AVG(edad) FROM ciclista GROUP BY nomequipo",
        ]);
        
        
    }
    
    public function actionSegundaconsulta5(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"select avg(edad) as mededad from ciclista group by nomequipo",
         
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
         return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mededad'],
            "titulo"=>"Consulta 5 con DAO",
            "enunciado"=>"La edad media de los ciclistas por cada equipo",
            "sql"=>"SELECT AVG(edad) FROM ciclista GROUP BY nomequipo'",
        ]);
}

public function actionConsulta6(){
        $dataprovider=new ActiveDataProvider([
            'query'=>Ciclista::find()->select("COUNT(edad) AS numciclistas")
                ->groupBy('nomequipo'),
            'pagination'=>[
                'pageSize'=>5,
                ]
            ]);
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['numciclistas'],
            "titulo"=>"Consulta 6 con Active Record",
            "enunciado"=>" El número de ciclistas por equipo",
            "sql"=>"SELECT COUNT(*) FROM ciclista GROUP BY nomequipo",
        ]);
        
        
    }
    
     public function actionSegundaconsulta6(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"select avg(edad) as mededad from ciclista group by nomequipo",
         
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'Consultas de selección 2';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de selección 2</h1>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 1</h3>
                        <p>Número de ciclistas que hay</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta1'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta1'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
            <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 2</h3>
                        <p>Número de ciclistas que hay</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta2'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta2'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
            <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 3</h3>
                        <p>Edad media de los ciclistas</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta3'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta3'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 4</h3>
                        <p> La edad media de los del equipo Banesto</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta4'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta4'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
              <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 5</h3>
                        <p> La edad media de los ciclistas por cada equipo</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta5'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta5'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                  
                  <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 6</h3>
                        <p> El número de ciclistas por equipo</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta6'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta6'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                      
                      <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 7</h3>
                        <p>  El número total de puertos</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta7'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta7'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                          
                         <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 8</h3>
                        <p>  El número total de puertos mayores de 1500</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta8'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta8'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>   
                             
                           <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 9</h3>
                        <p> Listar el nombre de los equipos que tengan más de 4 ciclistas</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta9'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta9'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>                
                
                      <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 10</h3>
                        <p> Listar el nombre de los equipos que tengan más de 4 ciclistas cuya edad esté entre 28 y 32</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta10'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta10'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div> 
                   
                    <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 11</h3>
                        <p> Indícame el número de etapas que ha ganado cada uno de los ciclistas</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta11'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta11'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div> 
                        
                    <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 12</h3>
                        <p> Indícame el dorsal de los ciclistas que hayan ganado más de una etapa</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta12'], ['class' => 'btn btn-primary'])?>
                            <?= Html::a('DAO', ['site/segundaconsulta12'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>          
                        
        </div>
    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>
<div class="jumbotron">
    <h2><?=$titulo?></h2>
    
    <p class="lead"><?=$enunciado?></p>
    <div class="well">
     <?= $sql ?>
    </div>    
   </div>

<?=GridView::widget([
    'dataProvider' => $resultados,
    'columns' =>$campos
]); ?>